#ifndef TYPON_CORE_CONTINUATION_HPP_INCLUDED
#define TYPON_CORE_CONTINUATION_HPP_INCLUDED

#include <coroutine>
#include <cstdint>


namespace typon
{

  struct Continuation
  {
    using u64 = std::uint_fast64_t;

    std::coroutine_handle<> _coroutine;
    u64 _thefts = 0;

    Continuation() noexcept {}

    Continuation(std::coroutine_handle<> coroutine) noexcept
      : _coroutine(coroutine)
    {}
  };

}


#endif // TYPON_CONTINUATION_HPP_INCLUDED
