#include <typon/core/task.hpp>

#include <cstdio>

using namespace typon;

Task<int> add(int a, int b) {
  co_return a + b;
}

Task<int> add_indirection(int a, int b) {
  co_return co_await add(a, b);
}

int main() {
  int result = add_indirection(2, 3).call();
  return result;
}
